version: '3.3' # optional since v1.27.0
services:
  task_manager_db:
    container_name: task_manager_db
    image: amazon/dynamodb-local
    hostname: task_manager_db
    user: root
    command: '-jar DynamoDBLocal.jar -sharedDb -dbPath /home/dynamodblocal/data/'
    volumes:
     - tm_dynamodb_data:/home/dynamodblocal/data
    ports:
      - '8002:8000'
  
  task_manager_api:
    image: task_manager:api
    container_name: task_manager_api
    build:
      context: ./backend
      dockerfile: Dockerfile
    entrypoint: /opt/docker-entrypoint.sh
    stdin_open: true
    depends_on:
      - 'task_manager_db'
    volumes:
      - './backend:/opt/api'
      - 'tm_api_node_modules:/opt/api/node_modules'
      - './docker-entrypoint.sh:/opt/docker-entrypoint.sh'
    ports:
      - '9000:9000' # localhost
      # - '192.168.236.142:9001:9000' # staging
      # - '192.168.16.12:81:9000' # production
    environment:
      - HOST=0.0.0.0
      - PORT=9000
      - ERROR_LOG=error.log
      - COMBINED_LOG=combined.log
      
      - AWS_DYNAMO_REGION=eu-central-1
      - AWS_DYNAMO_ACCESS_KEY_ID=key
      - AWS_DYNAMO_SECRET_KEY_ID=secret
      - AWS_DYNAMO_ENDPOINT=http://task_manager_db:8000

      - KEYCLOAK_CLIENT_ID=task-manager
      - KEYCLOAK_REALM=pimcity

      - SERVICES_PDS_CLIENT_ID=pds

      - REFERRALS_POINTS_THRESHOLD=100

      - DEP_HOST=task_manager_db
      - DEP_PORT=8000
  
  task_manager_frontend:
    image: task_manager:frontend
    container_name: task_manager_frontend
    build:
      context: ./frontend
      dockerfile: Dockerfile
    entrypoint: /opt/docker-entrypoint.sh
    stdin_open: true
    depends_on:
      - 'task_manager_api'
    volumes:
      - './frontend:/opt/frontend'
      - 'tm_frontend_node_modules:/opt/frontend/node_modules'
      - './docker-entrypoint.sh:/opt/docker-entrypoint.sh'
    ports:
      - '3002:3000'
      # - '192.168.236.142:3002:3000' # staging
      # - '192.168.16.12:82:3000' # production
    environment:
      - NODE_ENV=development
      - HOST=0.0.0.0
      - PORT=3000
      - DEP_HOST=task_manager_api
      - DEP_PORT=9000
      # - PUBLIC_URL=https://easypims.pimcity-h2020.eu/task-manager

volumes:
  tm_api_node_modules:
  tm_frontend_node_modules:
  tm_dynamodb_data: